package com.yifu.cloud.plus.v1.yifu.insurances.vo;

import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.yifu.cloud.plus.v1.yifu.common.core.constant.ExcelAttribute;
import com.yifu.cloud.plus.v1.yifu.common.core.vo.RowIndex;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;

/**
 * 含风险项目不购买申请表
 *
 * @author huych
 * @date 2025-01-10 11:24:38
 */
@Data
public class TInsuranceUnpurchaseApplyVo extends RowIndex implements Serializable {

	/**
	 * id
	 */
	@TableId(type = IdType.ASSIGN_ID)
	@NotBlank(message = "id 不能为空")
	@Length(max = 36, message = "id 不能超过36 个字符")
	@ExcelAttribute(name = "id", isNotEmpty = true, errorInfo = "id 不能为空", maxLength = 36)
	@Schema(description = "id")
	@ExcelProperty("id")
	private String id;
	/**
	 * 项目ID
	 */
	@Length(max = 32, message = "项目ID 不能超过32 个字符")
	@ExcelAttribute(name = "项目ID", maxLength = 32)
	@Schema(description = "项目ID")
	@ExcelProperty("项目ID")
	private String deptId;
	/**
	 * 项目编码
	 */
	@Length(max = 30, message = "项目编码 不能超过30 个字符")
	@ExcelAttribute(name = "项目编码", maxLength = 30)
	@Schema(description = "项目编码")
	@ExcelProperty("项目编码")
	private String deptNo;
	/**
	 * 项目名称
	 */
	@Length(max = 50, message = "项目名称 不能超过50 个字符")
	@ExcelAttribute(name = "项目名称", maxLength = 50)
	@Schema(description = "项目名称")
	@ExcelProperty("项目名称")
	private String deptName;
	/**
	 * 申请人所在部门
	 */
	@Length(max = 36, message = "申请人所在部门 不能超过36 个字符")
	@ExcelAttribute(name = "申请人所在部门", maxLength = 36)
	@Schema(description = "申请人所在部门")
	@ExcelProperty("申请人所在部门")
	private String createUserDeptId;
	/**
	 * 申请人所在部门名称
	 */
	@Length(max = 50, message = "申请人所在部门名称 不能超过50 个字符")
	@ExcelAttribute(name = "申请人所在部门名称", maxLength = 50)
	@Schema(description = "申请人所在部门名称")
	@ExcelProperty("申请人所在部门名称")
	private String createUserDeptName;
	/**
	 * 不购买原因 1 已购买社保 2 人员已离职
	 */
	@Length(max = 1, message = "不购买原因 1 已购买社保 2 人员已离职 不能超过1 个字符")
	@ExcelAttribute(name = "不购买原因 1 已购买社保 2 人员已离职", maxLength = 1)
	@Schema(description = "不购买原因 1 已购买社保 2 人员已离职")
	@ExcelProperty("不购买原因 1 已购买社保 2 人员已离职")
	private String reasonType;
	/**
	 * 原因说明
	 */
	@Length(max = 50, message = "原因说明 不能超过50 个字符")
	@ExcelAttribute(name = "原因说明", maxLength = 50)
	@Schema(description = "原因说明")
	@ExcelProperty("原因说明")
	private String reasonInfo;
	/**
	 * 申请编号
	 */
	@Length(max = 20, message = "申请编号 不能超过20 个字符")
	@ExcelAttribute(name = "申请编号", maxLength = 20)
	@Schema(description = "申请编号")
	@ExcelProperty("申请编号")
	private String applyNo;
	/**
	 * 项目是否有审批通过记录 0 是 1 否
	 */
	@Length(max = 1, message = "项目是否有审批通过记录 0 是 1 否 不能超过1 个字符")
	@ExcelAttribute(name = "项目是否有审批通过记录 0 是 1 否", maxLength = 1)
	@Schema(description = "项目是否有审批通过记录 0 是 1 否")
	@ExcelProperty("项目是否有审批通过记录 0 是 1 否")
	private String auditFlag;
	/**
	 * 申请人是否属于子分公司 0 是 1 否
	 */
	@Length(max = 1, message = "申请人是否属于子分公司 0 是 1 否 不能超过1 个字符")
	@ExcelAttribute(name = "申请人是否属于子分公司 0 是 1 否", maxLength = 1)
	@Schema(description = "申请人是否属于子分公司 0 是 1 否")
	@ExcelProperty("申请人是否属于子分公司 0 是 1 否")
	private String companyFlag;
	/**
	 * 是否删除 0未删除/1删除
	 */
	@Length(max = 1, message = "是否删除 0未删除/1删除 不能超过1 个字符")
	@ExcelAttribute(name = "是否删除 0未删除/1删除", maxLength = 1)
	@Schema(description = "是否删除 0未删除/1删除")
	@ExcelProperty("是否删除 0未删除/1删除")
	private String deleteFlag;
	/**
	 * 申请状态 0 草稿 1待提交 2 待审核 3 审核通过 4 审核不通过
	 */
	@Length(max = 1, message = "申请状态 0 草稿 1待提交 2 待审核 3 审核通过 4 审核不通过 不能超过1 个字符")
	@ExcelAttribute(name = "申请状态 0 草稿 1待提交 2 待审核 3 审核通过 4 审核不通过", maxLength = 1)
	@Schema(description = "申请状态 0 草稿 1待提交 2 待审核 3 审核通过 4 审核不通过")
	@ExcelProperty("申请状态 0 草稿 1待提交 2 待审核 3 审核通过 4 审核不通过")
	private String status;

}
